
;CodeVisionAVR C Compiler V2.03.8a Evaluation
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATtiny26
;Clock frequency        : 8,000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 30 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : Yes
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Smart register allocation : Off
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATtiny26
	#pragma AVRPART MEMORY PROG_FLASH 2048
	#pragma AVRPART MEMORY EEPROM 128
	#pragma AVRPART MEMORY INT_SRAM SIZE 128
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E

	.EQU WDTCR=0x21
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _usi_start_isr
	RJMP _usi_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x7E)
	LDI  R29,HIGH(0x7E)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x7E

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.03.8a Evaluation
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project : Robot suiveur de ligne
;Sous Projet : Test de la gestion I2C d'un afficheur
;Version : 1
;Date    : 24/02/2009
;Author  : Freeware, for evaluation and non-commercial use only
;Company :  Lyce Pierre Emile Martin 1, Av de Gionne 18000 BOURGES
;Comments:  Rception des caractres  envoyer sur l'afficheur par la
;           liaison I2C (USI) et affichage
;
;Chip type           : ATtiny26
;Clock frequency     : 8,000000 MHz (Oscillateur interne)
;Memory model        : Tiny
;External RAM size   : 0
;Data Stack size     : 32
;*****************************************************/
;
;#include <tiny26.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>    // contient la fonction delay_ms
;//#include <stdio.h>    // contient la fonction sprintf
;
;#include "USI_TWI_Slave.h"
;
;// Sample TWI transmission commands
;#define TWI_CMD_MASTER_WRITE 0x10
;#define TWI_CMD_MASTER_READ  0x20
;#define TWI_CMD_MASTER_WRITE_ALOT 0x30
;
;// Alphanumeric LCD Module functions
;//#asm
;//   .equ __lcd_port=0x1B ;PORTA
;//#endasm
;//#include <lcd.h>
;
;
;// Declare your global variables here
;
;
;void main(void)
; 0000 002E {

	.CSEG
_main:
; 0000 002F // -----------------------------------------------------------------------------------------------------
; 0000 0030 // Declare your global variables here
; 0000 0031 //-------------------------------------------------------------------------------------------------------
; 0000 0032 // type 	nom              				Description
; 0000 0033 //-------------------------------------------------------------------------------------------------------
; 0000 0034 //char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
; 0000 0035 //char display_buffer_ligne1[17]; 			// tampon ligne 1 de l'afficheur
; 0000 0036 
; 0000 0037 unsigned char TWI_slaveAddress, i, temp[8];
; 0000 0038 
; 0000 0039 // Input/Output Ports initialization
; 0000 003A // Port A initialization
; 0000 003B // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 003C // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 003D PORTA=0x38;
	SBIW R28,8
;	TWI_slaveAddress -> R16
;	i -> R17
;	temp -> Y+0
	LDI  R30,LOW(56)
	OUT  0x1B,R30
; 0000 003E DDRA=0x38;
	OUT  0x1A,R30
; 0000 003F 
; 0000 0040 // Port B initialization
; 0000 0041 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0042 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0043 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0044 DDRB=0x00;
	OUT  0x17,R30
; 0000 0045 
; 0000 0046 
; 0000 0047 // Universal Serial Interface initialization
; 0000 0048 // Mode: Two Wire (I2C)
; 0000 0049 // Clock source: Register & Counter=no clk.
; 0000 004A // USI Counter Overflow Interrupt: On
; 0000 004B // USI Start Condition Interrupt: On
; 0000 004C USICR=0xE0;
	LDI  R30,LOW(224)
	OUT  0xD,R30
; 0000 004D 
; 0000 004E 
; 0000 004F // LCD module initialization
; 0000 0050 //lcd_init(16);
; 0000 0051 
; 0000 0052 // Own TWI slave address
; 0000 0053   TWI_slaveAddress = 0x10;
	LDI  R16,LOW(16)
; 0000 0054   USI_TWI_Slave_Initialise( TWI_slaveAddress );
	ST   -Y,R16
	RCALL _USI_TWI_Slave_Initialise
; 0000 0055 
; 0000 0056 // Global enable interrupts
; 0000 0057 
; 0000 0058 
; 0000 0059 //lcd_clear();
; 0000 005A //sprintf(display_buffer_ligne0,"   Test I2C Rx  ");
; 0000 005B //sprintf(display_buffer_ligne1,"----------------");
; 0000 005C //lcd_puts(display_buffer_ligne0);
; 0000 005D //lcd_gotoxy(0,1);
; 0000 005E //lcd_puts(display_buffer_ligne1);
; 0000 005F //delay_ms(3000);
; 0000 0060 //lcd_clear();
; 0000 0061 
; 0000 0062 PORTA = 0x30;
	LDI  R30,LOW(48)
	RCALL SUBOPT_0x0
; 0000 0063 delay_ms(500);
; 0000 0064 PORTA = 0x28;
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x0
; 0000 0065 delay_ms(500);
; 0000 0066 
; 0000 0067 #asm("sei")
	sei
; 0000 0068 
; 0000 0069  // This loop runs forever. If the TWI Transceiver is busy the execution will just continue doing other operations.
; 0000 006A  for(;;)
_0x4:
; 0000 006B   {
; 0000 006C    for(i=0;i<8;i++)
	LDI  R17,LOW(0)
_0x7:
	CPI  R17,8
	BRSH _0x8
; 0000 006D    {
; 0000 006E     if( USI_TWI_Data_In_Receive_Buffer() )
	RCALL _USI_TWI_Data_In_Receive_Buffer
	CPI  R30,0
	BREQ _0x9
; 0000 006F     {
; 0000 0070         temp[i] = USI_TWI_Receive_Byte();
	MOV  R30,R17
	MOV  R26,R28
	ADD  R30,R26
	PUSH R30
	RCALL _USI_TWI_Receive_Byte
	POP  R26
	ST   X,R30
; 0000 0071         //USI_TWI_Transmit_Byte(temp);
; 0000 0072     }
; 0000 0073 
; 0000 0074     // Do something else while waiting for the TWI transceiver to complete.
; 0000 0075     // Put own code here.
; 0000 0076 
; 0000 0077     PORTA = temp[i]*8;
_0x9:
	MOV  R26,R28
	ADD  R26,R17
	LD   R30,X
	RCALL SUBOPT_0x1
	RCALL __LSLW3
	OUT  0x1B,R30
; 0000 0078     delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0079     }
	SUBI R17,-1
	RJMP _0x7
_0x8:
; 0000 007A   }
	RJMP _0x4
; 0000 007B }
_0xA:
	RJMP _0xA
;
;/*! \mainpage
; * \section Intro Introduction
; * This documents data structures, functions, variables, defines, enums, and
; * typedefs in the software for application note AVR312.
; *
; * \section CI Compilation Info
; * This software was written for the IAR Embedded Workbench 4.11A.
; *
; * To make project:
; * <ol>
; * <li> Add the file main.c and USI_TWI_Slave to project.
; * <li> Under processor configuration, select any AVR device with USI module.
; * <li> Enable bit definitions in I/O include files
; * <li> High optimization on size is recommended for lower code size.
; * </ol>
; *
; * \section DI Device Info
; * The included source code is written for all devices with with a USI module.
; *
; * \section TS Target setup
; * This example is made to work together with the AVR310 USI TWI Master application note. In adition to connecting the TWI
; * pins, also connect PORTB to the LEDS. The code reads a message as a TWI slave and acts according to if it is a
; * general call, or an address call. If it is an address call, then the first byte is considered a command byte and
; * it then responds differently according to the commands.
; *
; */
;
;
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_mask=0x18
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x18
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_Flush_TWI_Buffers:
	LDI  R30,LOW(0)
	STS  _TWI_RxTail_G100,R30
	STS  _TWI_RxHead_G100,R30
	STS  _TWI_TxTail_G100,R30
	STS  _TWI_TxHead_G100,R30
	RET
_USI_TWI_Slave_Initialise:
	RCALL _Flush_TWI_Buffers
	LD   R30,Y
	STS  _TWI_slaveAddress_G100,R30
	IN   R1,24
	RCALL SUBOPT_0x2
	OUT  0x18,R30
	IN   R1,24
	RCALL SUBOPT_0x3
	OR   R30,R1
	OUT  0x18,R30
	IN   R1,23
	RCALL SUBOPT_0x2
	OUT  0x17,R30
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	LDI  R30,LOW(240)
	OUT  0xE,R30
	ADIW R28,1
	RET
_USI_TWI_Receive_Byte:
	RCALL __SAVELOCR2
	LDS  R17,_TWI_RxTail_G100
_0x2000006:
	LDS  R26,_TWI_RxHead_G100
	CP   R17,R26
	BREQ _0x2000006
	LDS  R30,_TWI_RxTail_G100
	RCALL SUBOPT_0x1
	ADIW R30,1
	ANDI R30,LOW(0x7)
	ANDI R31,HIGH(0x7)
	MOV  R16,R30
	STS  _TWI_RxTail_G100,R16
	LDI  R26,LOW(_TWI_RxBuf_G100)
	ADD  R26,R16
	LD   R30,X
	RCALL __LOADLOCR2P
	RET
_USI_TWI_Data_In_Receive_Buffer:
	ST   -Y,R16
	LDS  R16,_TWI_RxTail_G100
	MOV  R30,R16
	LDS  R26,_TWI_RxHead_G100
	RCALL __NEB12
	LD   R16,Y+
	RET
_usi_start_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
	ST   -Y,R16
	IN   R16,14
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x5
_0x2000009:
	IN   R1,22
	LDI  R30,0
	SBIC 0x18,2
	LDI  R30,1
	RCALL SUBOPT_0xA
	AND  R1,R30
	RCALL SUBOPT_0xB
	AND  R30,R16
	RCALL __LNEGB1
	AND  R30,R1
	BRNE _0x2000009
	RCALL SUBOPT_0x6
	LDI  R30,0
	SBIC 0xD,6
	LDI  R30,1
	RCALL SUBOPT_0xA
	OR   R1,R30
	RCALL SUBOPT_0x7
	OR   R1,R30
	LDI  R30,0
	SBIC 0xD,4
	LDI  R30,1
	RCALL SUBOPT_0xA
	OR   R1,R30
	LDI  R30,0
	SBIC 0xD,3
	LDI  R30,1
	RCALL SUBOPT_0xA
	OR   R30,R1
	OUT  0xD,R30
	LDI  R30,0
	SBIC 0xE,7
	LDI  R30,1
	RCALL SUBOPT_0xA
	MOV  R1,R30
	RCALL SUBOPT_0xC
	OR   R1,R30
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	LD   R16,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
_usi_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RCALL __SAVELOCR2
	LDS  R30,_USI_TWI_Overflow_State_G100
	RCALL SUBOPT_0x1
	SBIW R30,0
	BRNE _0x200000F
	IN   R30,0xF
	CPI  R30,0
	BREQ _0x2000011
	IN   R30,0xF
	RCALL SUBOPT_0x1
	ASR  R31
	ROR  R30
	MOV  R26,R30
	MOV  R27,R31
	LDS  R30,_TWI_slaveAddress_G100
	RCALL SUBOPT_0x1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x2000010
_0x2000011:
	SBIS 0xF,0
	RJMP _0x2000013
	LDI  R30,LOW(1)
	RJMP _0x200001F
_0x2000013:
	LDI  R30,LOW(4)
_0x200001F:
	STS  _USI_TWI_Overflow_State_G100,R30
	LDI  R30,LOW(0)
	OUT  0xF,R30
	RCALL SUBOPT_0x4
	OR   R30,R1
	OUT  0x17,R30
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
	RJMP _0x2000020
_0x2000010:
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x11
_0x2000020:
	RCALL __LSLB12
	RCALL SUBOPT_0xE
	RJMP _0x200000E
_0x200000F:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x2000016
	IN   R30,0xF
	CPI  R30,0
	BREQ _0x2000017
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RJMP _0x2000023
_0x2000017:
	RJMP _0x2000018
_0x2000016:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2000019
_0x2000018:
	LDS  R16,_TWI_TxTail_G100
	LDS  R26,_TWI_TxHead_G100
	CP   R16,R26
	BREQ _0x200001A
	LDS  R30,_TWI_TxTail_G100
	RCALL SUBOPT_0x1
	ADIW R30,1
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	STS  _TWI_TxTail_G100,R30
	LDS  R30,_TWI_TxTail_G100
	SUBI R30,-LOW(_TWI_TxBuf_G100)
	LD   R30,Z
	OUT  0xF,R30
	RJMP _0x200001B
_0x200001A:
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RJMP _0x2000023
_0x200001B:
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x9
	OR   R30,R1
	OUT  0x17,R30
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x11
	RJMP _0x2000021
_0x2000019:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x200001C
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x5
	LDI  R30,LOW(0)
	OUT  0xF,R30
	RJMP _0x2000022
_0x200001C:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x200001D
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x11
	RJMP _0x2000021
_0x200001D:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x200000E
	IN   R17,15
	LDS  R30,_TWI_RxHead_G100
	RCALL SUBOPT_0x1
	ADIW R30,1
	ANDI R30,LOW(0x7)
	ANDI R31,HIGH(0x7)
	STS  _TWI_RxHead_G100,R30
	LDS  R30,_TWI_RxHead_G100
	SUBI R30,-LOW(_TWI_RxBuf_G100)
	ST   Z,R17
	LDI  R30,LOW(4)
	STS  _USI_TWI_Overflow_State_G100,R30
	LDI  R30,LOW(0)
	OUT  0xF,R30
	RCALL SUBOPT_0x4
	OR   R30,R1
	OUT  0x17,R30
_0x2000022:
	LDI  R30,0
	SBIC 0xE,6
	LDI  R30,1
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x10
_0x2000021:
	RCALL __LSLB12
	RCALL SUBOPT_0xE
_0x200000E:
_0x2000023:
	RCALL __LOADLOCR2P
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI

	.DSEG
_TWI_slaveAddress_G100:
	.BYTE 0x1
_USI_TWI_Overflow_State_G100:
	.BYTE 0x1
_TWI_RxBuf_G100:
	.BYTE 0x8
_TWI_RxHead_G100:
	.BYTE 0x1
_TWI_RxTail_G100:
	.BYTE 0x1
_TWI_TxBuf_G100:
	.BYTE 0x10
_TWI_TxHead_G100:
	.BYTE 0x1
_TWI_TxTail_G100:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	OUT  0x1B,R30
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x1:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	LDI  R30,0
	SBIC 0x18,2
	LDI  R30,1
	LDI  R26,LOW(1)
	RCALL __LSLB12
	OR   R30,R1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x3:
	LDI  R30,0
	SBIC 0x18,0
	LDI  R30,1
	LDI  R26,LOW(1)
	RCALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4:
	IN   R1,23
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5:
	COM  R30
	AND  R30,R1
	OUT  0x17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x6:
	LDI  R30,0
	SBIC 0xD,7
	LDI  R30,1
	LDI  R26,LOW(1)
	RCALL __LSLB12
	MOV  R1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x7:
	LDI  R30,0
	SBIC 0xD,5
	LDI  R30,1
	LDI  R26,LOW(1)
	RCALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x8:
	OR   R30,R1
	MOV  R1,R30
	LDI  R30,0
	SBIC 0xD,3
	LDI  R30,1
	LDI  R26,LOW(1)
	RCALL __LSLB12
	OR   R30,R1
	OUT  0xD,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x9:
	STS  _USI_TWI_Overflow_State_G100,R30
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 27 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0xA:
	LDI  R26,LOW(1)
	RCALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xB:
	LDI  R30,0
	SBIC 0xE,5
	LDI  R30,1
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0xC:
	LDI  R30,0
	SBIC 0xE,6
	LDI  R30,1
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0xD:
	OR   R1,R30
	LDI  R30,0
	SBIC 0xE,4
	LDI  R30,1
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	OR   R30,R1
	OUT  0xE,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	MOV  R1,R30
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	OR   R1,R30
	LDI  R30,0
	SBIC 0xE,0
	LDI  R30,1
	LDI  R26,LOW(14)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x11:
	OR   R1,R30
	LDI  R30,0
	SBIC 0xE,4
	LDI  R30,1
	LDI  R26,LOW(1)
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__NEB12:
	CP   R30,R26
	LDI  R30,1
	BRNE __NEB12T
	CLR  R30
__NEB12T:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
