/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.8a Evaluation
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : Robot suiveur de ligne
Sous Projet : Test de la gestion I2C d'un afficheur
Version : 1
Date    : 24/02/2009
Author  : Freeware, for evaluation and non-commercial use only
Company :  Lyce Pierre Emile Martin 1, Av de Gionne 18000 BOURGES
Comments:  Rception des caractres  envoyer sur l'afficheur par la
           liaison I2C (USI) et affichage 

Chip type           : ATtiny26
Clock frequency     : 8,000000 MHz (Oscillateur interne)
Memory model        : Tiny
External RAM size   : 0
Data Stack size     : 32
*****************************************************/

#include <tiny26.h>
//#include <delay.h>    // contient la fonction delay_ms
//#include <stdio.h>    // contient la fonction sprintf

#include "USI_TWI_Slave.h"

// Sample TWI transmission commands
#define TWI_CMD_MASTER_WRITE 0x10
#define TWI_CMD_MASTER_READ  0x20
#define TWI_CMD_MASTER_WRITE_ALOT 0x30

// Alphanumeric LCD Module functions
//#asm
//   .equ __lcd_port=0x1B ;PORTA
//#endasm
//#include <lcd.h>


// Declare your global variables here


void main(void)
{
// -----------------------------------------------------------------------------------------------------
// Declare your global variables here  
//-------------------------------------------------------------------------------------------------------
// type 	nom              				Description
//-------------------------------------------------------------------------------------------------------
//char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
//char display_buffer_ligne1[17]; 			// tampon ligne 1 de l'afficheur

unsigned char TWI_slaveAddress, temp;
 
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;


// Universal Serial Interface initialization
// Mode: Two Wire (I2C)
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: On
// USI Start Condition Interrupt: On
USICR=0xE0;


// LCD module initialization
//lcd_init(16);

// Own TWI slave address
  TWI_slaveAddress = 0x10;
  USI_TWI_Slave_Initialise( TWI_slaveAddress );

// Global enable interrupts
#asm("sei")

//lcd_clear();
//sprintf(display_buffer_ligne0,"   Test I2C Rx  ");
//sprintf(display_buffer_ligne1,"----------------");
//lcd_puts(display_buffer_ligne0);
//lcd_gotoxy(0,1);
//lcd_puts(display_buffer_ligne1);
//delay_ms(3000);
//lcd_clear();

 // This loop runs forever. If the TWI Transceiver is busy the execution will just continue doing other operations.
 for(;;)
  {

    if( USI_TWI_Data_In_Receive_Buffer() )
    {
        temp = USI_TWI_Receive_Byte();
        PORTB = temp;
        USI_TWI_Transmit_Byte(temp);
    }

    // Do something else while waiting for the TWI transceiver to complete.
    // Put own code here.
  }
}

/*! \mainpage
 * \section Intro Introduction
 * This documents data structures, functions, variables, defines, enums, and
 * typedefs in the software for application note AVR312.
 *
 * \section CI Compilation Info
 * This software was written for the IAR Embedded Workbench 4.11A.
 *
 * To make project:
 * <ol>
 * <li> Add the file main.c and USI_TWI_Slave to project.
 * <li> Under processor configuration, select any AVR device with USI module.
 * <li> Enable bit definitions in I/O include files
 * <li> High optimization on size is recommended for lower code size.
 * </ol>
 *
 * \section DI Device Info
 * The included source code is written for all devices with with a USI module.
 *
 * \section TS Target setup
 * This example is made to work together with the AVR310 USI TWI Master application note. In adition to connecting the TWI
 * pins, also connect PORTB to the LEDS. The code reads a message as a TWI slave and acts according to if it is a
 * general call, or an address call. If it is an address call, then the first byte is considered a command byte and
 * it then responds differently according to the commands.
 *
 */


